/**
 * ScandiPWA - Progressive Web App for Magento
 *
 * Copyright © Scandiweb, Inc. All rights reserved.
 * See LICENSE for license details.
 *
 * @license OSL-3.0 (Open Software License ("OSL") v. 3.0)
 * @package scandipwa/base-theme
 * @link https://github.com/scandipwa/base-theme
 */
@mixin button-disabled {
    opacity: 0.25;
    cursor: not-allowed;
}

@mixin button {

    display: inline-block;
    padding: var(--button-padding);
    border-radius: 0;
    color: var(--button-color);
    background-color: var(--button-background);
    font-size: 1.1rem;
    font-weight: 500;
    text-transform: uppercase;
    text-decoration: none; // because we never need underlines in buttons
    transition-property: background-color, color, border;
    transition-duration: 0.25s;
    transition-timing-function: ease-out;
    cursor: pointer;
    will-change: background-color, color, border;
    border: {
        width: var(--button-border-width);
        color: var(--button-border);
        style: solid;
    }

    &:hover,
    &:focus {
        text-decoration: none;
    }

    &:not([disabled]) {
        &:hover,
        &:focus {
            @include after-mobile {
                border-color: var(--button-hover-border);
                color: var(--button-hover-color);
                background-color: var(--button-hover-background);
            }
        }
    }

    &[disabled] {
        @include button-disabled();
    }

    &_isHollow {
        border-color: var(--button-background);
        color: var(--button-background);
        background: transparent;
    }

    &_likeLink {
        --button-border: transparent;
        --button-background: transparent;
        --button-color: var(--primary-base-color);
        --button-hover-border: transparent;
        --button-hover-background: transparent;
        --button-hover-color: var(--primary-base-color);
        padding: 0;
        margin: 0;
        font-weight: normal;
        text-align: left;

        text-transform: none;

        &:hover,
        &:focus {
            text-decoration: underline;
        }
    }
}

@mixin verticalButtonLeft {
    position: absolute;
    top: 0;
    left: 0;
    transform: scale(-1, -1);

    button {
        padding: 10px;
        border: 1px solid $grey-1-color;
        border-bottom: 0;
        transform: rotate(90deg);
        transform-origin: right bottom;
    }
}
